#include <stdio.h>
#include "opencv2\opencv.hpp"
 
#ifdef _DEBUG
    //Debug[h̏ꍇ
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_core241d.lib")
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_imgproc241d.lib")
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_highgui241d.lib")
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_objdetect241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_contrib241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_features2d241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_flann241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_gpu241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_haartraining_engined.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_legacy241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_ts241d.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_video241d.lib")
#else
    //Release[h̏ꍇ
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_core241.lib")
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_imgproc241.lib")
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_highgui241.lib")
    #pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_objdetect241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_contrib241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_features2d241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_flann241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_gpu241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_haartraining_engined.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_legacy241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_ts241.lib")
    //#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_video241.lib")
#endif

/* vZ */
#define GRIDSIZE 500                     // ObhTCY@
                                         // ł500x500ɌŒ
#define WBAND 10                         // NarrowBand̕
#define WRESET 3                         // Zbg̈̕
#define INITIALOFFSET 1                  // Ȗʂ̃ItZbg
#define MAXNARROWBAND 100*GRIDSIZE*WBAND // Narrow Band̍ő
                                         // Obh
#define MAXFRONT 100*GRIDSIZE            // FrontiEj
                                         // őObh

enum{FARAWAY,BAND,RESETBAND,FRONT};      // status̃x

/* x֐p[^ */
#define DT 1                             // ԍ
#define GAIN 0.1                         // ȗ̃QC

/* ϐ */
double phi[GRIDSIZE][GRIDSIZE];          // ⏕֐
double dphi[GRIDSIZE][GRIDSIZE];         // ⏕֐̕ω
double F[GRIDSIZE][GRIDSIZE];            // x֐
unsigned char gray[GRIDSIZE][GRIDSIZE];  // 摜̋Px
unsigned char status[GRIDSIZE][GRIDSIZE];// ݂̏
double Front[MAXFRONT][2];               // Front̃Obh
int NFront;                              // Front̃Obh
int NarrowBand[MAXNARROWBAND][2];    // NarrowNand̃Obh
int NNarrowBand;                     // NarrowNand̃Obh
int CircleMap[WBAND+1][7*(WBAND+1)][2];  // }bvp
int NCircleMap[WBAND+1];                 // }bv
                                         // ẽsNZ

/* ֐ */
void InitializeFrontPosition();          // Front ̐ݒ
double SetSpeedFunction(int);            // NarrowBandŐxݒ 1ȂNarrowBand ̐ݒƋ֐̌vZ
void FrontPropagation();                 // Front̐
int ReLabeling();                        // Front̃x쐬
void InitializeCircleMap();              // }bv̍쐬

/* OpenGL */
IplImage* img;
IplImage* dst;
void DrawContour();


#ifdef max
#undef max
#endif
#define max(a,b) (a>b)?a:b
#ifdef min
#undef min
#endif
#define min(a,b) (a<b)?a:b


#define USAGE(argv) \
{ \
    fprintf(stderr,"Usage %s imagefile \n",argv[0]); \
    exit(-1); \
}

// }bv̍쐬
void InitializeCircleMap()
{
    for(int i=0;i<=WBAND;i++) NCircleMap[i] = 0;

    // ~̋}bv쐬@
    // CircleMap[][f[^̔ԍ][0-2]  }bv@
    // NCircleMap[]                     }bṽf[^
    for(int x=-WBAND;x<=WBAND;x++){
        for(int y=-WBAND;y<=WBAND;y++){
            int d;
            if((d = int(sqrt(double(x*x+y*y)))) <= WBAND){
                CircleMap[d][NCircleMap[d]][0] = x;
                CircleMap[d][NCircleMap[d]][1] = y;
                NCircleMap[d] ++;
            }
        }
    }
}

// Front ̏ݒ
void InitializeFrontPosition()
{
    int n=0;

    memset(status,FARAWAY,sizeof(status));

    // FrontObhݒ
    for(int x=INITIALOFFSET;x<GRIDSIZE-INITIALOFFSET;x++){
        status[x][INITIALOFFSET] = FRONT;
        Front[n][0] = x;
        Front[n][1] = INITIALOFFSET;
        phi[x][INITIALOFFSET] = 0.0;
        n++;
    }
    for(int y=INITIALOFFSET;y<GRIDSIZE-INITIALOFFSET;y++){
        status[GRIDSIZE-1-INITIALOFFSET][y] = FRONT;
        Front[n][0] = GRIDSIZE-1-INITIALOFFSET;
        Front[n][1] = y;
        phi[GRIDSIZE-1-INITIALOFFSET][y] = 0.0;
        n++;
    }
    for(int x=GRIDSIZE-1-INITIALOFFSET;x>=INITIALOFFSET;x--){
        status[x][GRIDSIZE-1-INITIALOFFSET] = FRONT;
        Front[n][0] = x;
        Front[n][1] = GRIDSIZE-1-INITIALOFFSET;
        phi[x][GRIDSIZE-1-INITIALOFFSET] = 0.0;
        n++;
    }
    for(int y=GRIDSIZE-1-INITIALOFFSET;y>=INITIALOFFSET;y--){
        status[INITIALOFFSET][y] = FRONT;
        Front[n][0] = INITIALOFFSET;
        Front[n][1] = y;
        phi[INITIALOFFSET][y] = 0.0;
        n++;
    }
    NFront = n;

    // ̑̏ꏊ
    for(int x=0;x<GRIDSIZE;x++){
        for(int y=0;y<GRIDSIZE;y++){
            if(status[x][y] != FRONT){
                // ֐̐̕iOjݒ肵Ă
                if(x>INITIALOFFSET && x<GRIDSIZE-INITIALOFFSET-1 
                  && y>INITIALOFFSET && y<GRIDSIZE-INITIALOFFSET-1){
                    phi[x][y] =-WBAND;
                } else { 
                    phi[x][y] = WBAND;
                }
            }
        }
    }

    // NarrowBand̐ݒ
    NNarrowBand = 0;
    SetSpeedFunction(1);
}

// NarrowBandŐxݒ
double SetSpeedFunction(int reset)
{
    double dx, dy;
    double dfx, dfy, dfx2, dfy2, dfxy, df;
    double kappa;
    double Fs = 0;

    // Narrow Band̐xNA
    for(int i=0; i<NNarrowBand; i++){
        int x = NarrowBand[i][0];
        int y = NarrowBand[i][1];
        F[x][y] = 0.0;
        dphi[x][y] = 0.0;
        // NarrowBand̍ď
        if(reset) {
            if(status[x][y] != FRONT) status[x][y] = FARAWAY;
         }
    }

    // Front̐xݒ
    for(int i=0;i<NFront;i++){
        // PxzŐxݒ
        int x = int(Front[i][0]);
        int y = int(Front[i][1]);

        if(x<1||x>GRIDSIZE-2||y<1||y>GRIDSIZE-2) continue;

        dx = gray[x+1][y] - gray[x][y];
        dy = gray[x][y+1] - gray[x][y];

        F[x][y] = 1.0 / (1.0+sqrt(dx*dx+dy*dy));

        // ȗvZ
        dfx = ((phi[x+1][y+1] - phi[x-1][y+1])
                + 2.0*(phi[x+1][y] - phi[x-1][y])
                + (phi[x+1][y-1] - phi[x-1][y-1]))/4.0/2.0;
        dfy = ((phi[x+1][y+1] - phi[x+1][y-1])
                + 2.0*(phi[x][y+1] - phi[x][y-1])
                + (phi[x-1][y+1] - phi[x-1][y-1]))/4.0/2.0;
        dfxy = ((phi[x+1][y+1] - phi[x-1][y+1])
                - (phi[x+1][y-1] - phi[x-1][y-1])) / 2.0 / 2.0;
        dfx2 = ((phi[x+1][y+1] + phi[x-1][y+1] - 2.0 * phi[x][y+1])
                + 2.0*(phi[x+1][y] + phi[x-1][y] - 2.0 * phi[x][y])
                +(phi[x+1][y-1] + phi[x-1][y-1] - 2.0 * phi[x][y-1]))/4.0;
        dfy2 = ((phi[x+1][y+1] + phi[x+1][y-1] - 2.0 * phi[x+1][y])
                + 2.0*(phi[x][y+1] + phi[x][y-1] - 2.0 * phi[x][y])
                +(phi[x-1][y+1] + phi[x-1][y-1] - 2.0 * phi[x-1][y]))/4.0;
                
        if((df = sqrt(dfx*dfx+dfy*dfy)) != 0.0)
            kappa = (dfx2 * dfy * dfy - 2.0 * dfx * dfy * dfxy 
                    + dfy2 * dfx * dfx) / (df * df * df);
        else kappa = 0.0;

        // Front̐x̌
        F[x][y] *= (-1.0 - GAIN * kappa);

        Fs += F[x][y];

    }

    // NarrowBandł̐xɁCł߂Front̐xRs[
    // }bvɏ㏑
    for(int d=WBAND;d>0;d--){
        for(int i=0;i<NFront;i++){
            int xf = int(Front[i][0]);
            int yf = int(Front[i][1]);

            // Front̍ď
            if(reset) phi[xf][yf] = 0.0;

            for(int j=0;j<NCircleMap[d];j++){
                int x = xf+CircleMap[d][j][0];
                int y = yf+CircleMap[d][j][1];

                if(x<0||x>GRIDSIZE-1||y<0||y>GRIDSIZE-1) continue;
                if(status[x][y] == FRONT) continue;

                // NarrowBand̍ď
                if(reset){
                    if(d>WBAND-WRESET) status[x][y] = RESETBAND;
                    else status[x][y] = BAND;
                    // OԂ̕Rs[
                    phi[x][y] = (phi[x][y] < 0) ? -d : d;
                }

                // FrontłȂΏ㏑
                F[x][y] = F[xf][yf];
            }
        }
    }

    if(reset){
        // Narrow Bandɓo^
        int n = 0;
        for(int x=0;x<GRIDSIZE;x++){
            for(int y=0;y<GRIDSIZE;y++){
                if(status[x][y] != FARAWAY){
                    NarrowBand[n][0] = x;
                    NarrowBand[n][1] = y;
                    if(n++>=MAXNARROWBAND) {
                        printf("Too many NarrowBand points\n");
                        return 0;
                    }
                }
            }
        }
       NNarrowBand = n;
    }

     return Fs;

}

// Front𐬒
void FrontPropagation()
{
    double fdxm, fdxp, fdym, fdyp;

    for(int i=0; i<NNarrowBand; i++){
        int x = NarrowBand[i][0];
        int y = NarrowBand[i][1];

        if(x<1||x>GRIDSIZE-2||y<1||y>GRIDSIZE-2) continue;

       // Upwind scheme
       if(F[x][y]>0.0){
            fdxm = max(phi[x][y] - phi[x-1][y],0);
            fdxp = min(phi[x+1][y] - phi[x][y],0);
            fdym = max(phi[x][y] - phi[x][y-1],0);
            fdyp = min(phi[x][y+1] - phi[x][y],0);
            dphi[x][y] = F[x][y] * 
              sqrt(fdxm*fdxm+fdxp*fdxp+fdym*fdym+fdyp*fdyp) * DT;
        } else {
            fdxp = max(phi[x+1][y] - phi[x][y],0);
            fdxm = min(phi[x][y] - phi[x-1][y],0);
            fdyp = max(phi[x][y+1] - phi[x][y],0);
            fdym = min(phi[x][y] - phi[x][y-1],0);
            dphi[x][y] = F[x][y] * 
              sqrt(fdxm*fdxm+fdxp*fdxp+fdym*fdym+fdyp*fdyp) * DT;
        }
    }

    for(int i=0; i<NNarrowBand; i++){
        int x = NarrowBand[i][0];
        int y = NarrowBand[i][1];
        phi[x][y] -= dphi[x][y];
    }
}

// Front̃x쐬
int ReLabeling()
{
    int n=0;
    int flg = 0;

    for(int i=0; i<NNarrowBand; i++){
        int x = NarrowBand[i][0];
        int y = NarrowBand[i][1];

        if(x<1||x>GRIDSIZE-2||y<1||y>GRIDSIZE-2) continue;

        // ׂŕς`FbN
        if((phi[x][y]>=0.0 && 
           ((phi[x+1][y]+phi[x][y]<=0.0) || (phi[x][y+1]+phi[x][y]<=0.0) ||
            (phi[x-1][y]+phi[x][y]<=0.0) || (phi[x][y-1]+phi[x][y]<=0.0))) ||
           (phi[x][y]<=0.0 &&
           ((phi[x+1][y]+phi[x][y]>=0.0) || (phi[x][y+1]+phi[x][y]>=0.0) ||
            (phi[x-1][y]+phi[x][y]>=0.0) || (phi[x][y-1]+phi[x][y]>=0.0)))){
                
            // FrontNarrow Band̒[ɓB̂
            // Narrrow BandAbvf[g
            if(status[x][y] == RESETBAND) flg = 1;
                
            // Frontɒǉ
            status[x][y] = FRONT;
            Front[n][0] = x;
            Front[n][1] = y;

            if(n++>=MAXFRONT) {
                printf("Too many Front points\n");
                return -1;
            }
        } else {
            if(status[x][y] == FRONT) status[x][y] = BAND;
        }
    }

    NFront = n;

    // Frontďׂ̈ɓBH
    return flg;
}

// Front\
void DrawContour()
{
    CvScalar c = CV_RGB( 100, 100, 100);

    cvCopy(img,dst);

    for(int i=0;i<NFront-1;i++){
        cvRectangle( dst, cvPoint(int(Front[i][1]),int(Front[i][0])), 
                     cvPoint(int(Front[i][1])+1,int(Front[i][0])+1), c);    
    }

}

// C֐
void main( int argc, char** argv )
{
    if(argc<2) USAGE(argv);

    if(!(img = cvLoadImage( argv[1], CV_LOAD_IMAGE_GRAYSCALE ))) {
        USAGE(argv);
    }
    if(img->width != GRIDSIZE || img->height!= GRIDSIZE){
        printf("Image size must be %d x %d\n",GRIDSIZE,GRIDSIZE);
        cvReleaseImage( &img );
        exit(-1);
    }

    dst = cvCloneImage(img);

    if(img) memcpy(gray, img->imageData, GRIDSIZE*GRIDSIZE);

    cvNamedWindow( "Image", 1 );
    cvResizeWindow( "Image", img->width, img->height );

    // }bv̍쐬
    InitializeCircleMap();

    // FrontNarrow Band ̐ݒ
    InitializeFrontPosition();

    int reset = 1;
    double Fs = 0;

    do{

        cvShowImage( "Image", dst );

        // NarrowBandŐxݒ
        if((Fs = SetSpeedFunction(reset))==0.0) break;

        // Front𐬒
        FrontPropagation();

        // Front̃x쐬
        if((reset = ReLabeling())<0) break;

        // Front`
        DrawContour();

        int key = cvWaitKey(10);

        if(key=='q' ||  key==27){
            break;
        }

    } while(cvGetWindowHandle("Image"));

    cvReleaseImage( &img );
    cvReleaseImage( &dst );
    cvDestroyWindow("Image");
}
